#NoTrayIcon
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icons\prog.ico
#AutoIt3Wrapper_outfile=Starplayer.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Starplayer
#AutoIt3Wrapper_Res_Fileversion=3.0.1.6
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Date.au3>
#include <EditConstants.au3>
#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <ListViewConstants.au3>
#include <Math.au3>
#include <ProgressConstants.au3>
#include <SliderConstants.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <Timers.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

#include 'includes\ID3Tag.au3'
#include 'includes\_RecursiveFileListToArray.au3'

#include 'bass\BassConstants.au3'
#include 'bass\Bass.au3'
#include 'bass\BassTags.au3'

Opt('GUIOnEventMode', 1)

Global $sTitle = 'Starplayer v3'
Global $sVersion = '3.0.1.6'
Global $sDate = '2010-07-24'
Global $iSelfPID = _WinAPI_GetCurrentProcessID()
Global $aProcessList = ProcessList('Starplayer.exe')
If $aProcessList[0][0] > 1 Then
	If $iSelfPID <> $aProcessList[1][1] Then WinWait('Starplayer Playlist')
EndIf
If WinExists('Starplayer Playlist') Then ; If Starplayer exists, then send Commandline to 1st instance.
	If $CmdLine[0] > 0 Then
		For $i = 1 To $CmdLine[0]
			If FileExists($CmdLine[$i]) Then
				Switch StringRight($CmdLine[$i], 4)
					Case '.mp3'
						ConsoleWrite($CmdLine[$i] & @CRLF)
						ControlCommand('Starplayer Playlist', '', '[CLASS:Edit; INSTANCE:1]', 'EditPaste', $CmdLine[$i] & @CRLF)
					Case '.m3u'
						$sWorkDir = StringRegExpReplace($CmdLine[$i], '(.+\\).+', '$1')
						$aNewFiles = StringSplit(FileRead($CmdLine[$i]), @CRLF, 1)
						For $j = 1 To $aNewFiles[0]
							If Not StringInStr($aNewFiles[$j], '\') Then $aNewFiles[$j] = $sWorkDir & $aNewFiles[$j]
							If StringRight($aNewFiles[$j], 4) = '.mp3' And FileExists($aNewFiles[$j]) Then
								ControlCommand('Starplayer Playlist', '', '[CLASS:Edit; INSTANCE:1]', 'EditPaste', $aNewFiles[$j] & @CRLF)
							EndIf
						Next
				EndSwitch
			EndIf
		Next
		ControlClick('Starplayer Playlist', '', '[CLASS:Button; INSTANCE:1]')
	EndIf
	Exit ; Only one instance. Exit the 2nd.
EndIf

_BASS_STARTUP(@ScriptDir & '\bass\bass.dll')
_Bass_Tags_Startup(@ScriptDir & '\bass\BassTags.dll')
_BASS_Init(0, -1, 44100, 0, '')
If @error Then Exit MsgBox(16, $sTitle, 'Error!' & @CRLF & 'Cannot initialize Soundcard!')

Global $sAppDir = IniRead(@ScriptDir & '\Starplayer.ini', 'Settings', 'AppDir', @AppDataDir & '\StarplayerV3\')
If $sAppDir <> '' And Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'Starplayer.ini'
If Not IniWrite($sInifile, 'Settings', 'AppDir', $sAppDir) Then
	$sAppDir = @AppDataDir & '\StarplayerV3\'
	If Not FileExists($sAppDir) Then DirCreate($sAppDir)
	$sInifile = $sAppDir & 'Starplayer.ini'
EndIf
If Not FileExists($sInifile) Then SoundSetWaveVolume(50)

Global $iMainPosX = IniRead($sInifile, 'Settings', 'MainPosX', @DesktopWidth / 2 - 280)
Global $iMainPosY = IniRead($sInifile, 'Settings', 'MainPosY', @DesktopHeight / 2 - 110)
Global $iFadeTime = IniRead($sInifile, 'Settings', 'FadeTime', 10)
Global $fTooltips = Execute(IniRead($sInifile, 'Settings', 'Tooltips', True))
Global $fSoundinfos = Execute(IniRead($sInifile, 'Settings', 'Soundinfos', True))
Global $fFadeOut = Execute(IniRead($sInifile, 'Settings', 'FadeOut', True))
Global $fOnTop = Execute(IniRead($sInifile, 'Settings', 'OnTop', True))
Global $fRepeat = Execute(IniRead($sInifile, 'Settings', 'Repeat', False))
Global $iScriptVolume = IniRead($sInifile, 'Settings', 'ScriptVolume', 100)

Global $iPeakL, $iPeakR, $iHigh = 32768, $iLength, $iSeconds, $iOld, $fMuteVolume = False, $iMuteVolume = 100
Global $iWidth = 500, $sPath, $hSoundOpen = -1, $hSoundFade = -1, $iFadeVol = 100, $iStart = 0, $iHover = -1
Global $ahPlItem[1], $iPlCount = 0, $iPlayIndex = -1, $sID3Tags, $fPause = False
Global $iFadeLength = 5000
Global $gaDropFiles[1]
Global Const $WM_DROPFILES = 0x233
Global $sIconDir = @ScriptDir & '\icons\'
Global $iWinBorder = 2 * _WinAPI_GetSystemMetrics($SM_CYFRAME)

; --- Begin Main-GUI ---
$hGui = GUICreate($sTitle, 560, 220, $iMainPosX, $iMainPosY, BitOR($WS_POPUPWINDOW, $WS_THICKFRAME), $WS_EX_CONTROLPARENT)
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, '_SetPosition')
GUISetOnEvent($GUI_EVENT_CLOSE, '_Exit')
GUISetIcon(@ScriptDir & '\icons\prog.ico')
GUISetBkColor(0x000000)

GUICtrlCreatePic($sIconDir & 'backgr.jpg', 0, 0, 560, 160)
GUICtrlSetState(-1, $GUI_DISABLE)

$hStar = GUICtrlCreateIcon($sIconDir & 'about.ico', -1, 8, 8, 32, 32)
$sTip = StringFormat('%s\nVersion:\t%s\nDate:\t%s\nAuthor:\tOscar (www.autoit.de)\n', $sTitle, $sVersion, $sDate)
GUICtrlSetTip(-1, $sTip)

$hMin = GUICtrlCreateIcon($sIconDir & 'min0.ico', -1, 509, 0, 24, 15)
GUICtrlSetOnEvent(-1, '_Minimize')

$hClose = GUICtrlCreateIcon($sIconDir & 'close0.ico', -1, 533, 0, 28, 15)
GUICtrlSetOnEvent(-1, '_Exit')

$hLabel = GUICtrlCreateLabel('Select MP3-File...', 50, 22, 500, 28, $SS_LEFTNOWORDWRAP, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 16, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Position', 2, 51, 44, 20, $SS_RIGHT, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)


DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hPosition = GUICtrlCreateProgress(50, 50, 500, 20, $PBS_SMOOTH)
GUICtrlSetBkColor(-1, 0x222222)
GUICtrlSetColor(-1, 0xFFBB55)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style

$hDuration = GUICtrlCreateLabel('00:00 / 00:00', 220, 72, 130, 32, Default, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 14, 400, 0, 'Tahoma')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hConfig = GUICtrlCreateIcon($sIconDir & 'config_close0.ico', -1, 0, 109, 14, 44)
GUICtrlSetOnEvent(-1, '_ShowConfig')

GUICtrlCreateLabel('Left', 16, 108, 30, 20, $SS_RIGHT, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateLabel('Right', 16, 138, 30, 20, $SS_RIGHT, $GUI_WS_EX_PARENTDRAG)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hPLShow = GUICtrlCreateIcon($sIconDir & 'playlist0.ico', -1, 4, 170, 48, 48)
GUICtrlSetOnEvent(-1, '_ShowPlaylist')

$hPrev = GUICtrlCreateIcon($sIconDir & 'prev0.ico', -1, 180, 170, 48, 48)
GUICtrlSetOnEvent(-1, '_PrevSound')

$hStop = GUICtrlCreateIcon($sIconDir & 'stop0.ico', -1, 230, 170, 48, 48)
GUICtrlSetOnEvent(-1, '_StopSound')

$hPlay = GUICtrlCreateIcon($sIconDir & 'play0.ico', -1, 280, 170, 48, 48)
GUICtrlSetOnEvent(-1, '_StartSound')

$hNext = GUICtrlCreateIcon($sIconDir & 'next0.ico', -1, 330, 170, 48, 48)
GUICtrlSetOnEvent(-1, '_NextSound')
; --- End Main-GUI ---

$aGuiPos = WinGetPos($hGui)

; --- Begin Playlist-GUI ---
$hPLGui = GUICreate('Starplayer Playlist', 560, 380, $aGuiPos[0], $aGuiPos[1] + 220 + $iWinBorder, BitOR($WS_POPUPWINDOW, $WS_THICKFRAME), $WS_EX_ACCEPTFILES + $WS_EX_CONTROLPARENT, $hGui)
GUISetBkColor(0x161616)
GUISetOnEvent($GUI_EVENT_DROPPED, '_DropEvent')

$LV_Style = BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER)
$LV_EX_STYLE = BitOR($WS_EX_CLIENTEDGE, $LVS_EX_FULLROWSELECT, $LVS_EX_DOUBLEBUFFER)
$hPlaylist = GUICtrlCreateListView('Nr.|Artist|Title|Duration|Bitrate|Path', 50, 10, 500, 300, $LV_Style, $LV_EX_STYLE)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)
GUICtrlSetBkColor(-1, 0xDDDDDD)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 0, 32)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 1, 170)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 2, 210)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 3, 70)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 4, 70)
GUICtrlSendMsg($hPlaylist, $LVM_SETCOLUMNWIDTH, 5, 200)

$hPLUp = GUICtrlCreateIcon($sIconDir & 'up0.ico', -1, 10, 40, 32, 32)
GUICtrlSetOnEvent(-1, '_PlaylistUp')

GUICtrlCreateLabel('', 26, 74, 24, 2, Default, $WS_EX_STATICEDGE)
GUICtrlCreateLabel('', 26, 70, 2, 10, Default, $WS_EX_STATICEDGE)

$hPLDown = GUICtrlCreateIcon($sIconDir & 'down0.ico', -1, 10, 80, 32, 32)
GUICtrlSetOnEvent(-1, '_PlaylistDown')

GUICtrlCreateLabel('Volume', 8, 125, 40, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)

$hVolume = GUICtrlCreateSlider(15, 140, 30, 175, BitOR($TBS_VERT, $TBS_AUTOTICKS))
GUICtrlSetBkColor(-1, 0x161616)
GUICtrlSetData(-1, 100 - $iScriptVolume)

$hMute = GUICtrlCreateIcon($sIconDir & 'volcontrol0.ico', -1, 10, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_MuteVolume')

$hPLNew = GUICtrlCreateIcon($sIconDir & 'playlistnew0.ico', -1, 130, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_NewPlaylist')

$hPLLoad = GUICtrlCreateIcon($sIconDir & 'playlistopen0.ico', -1, 170, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_LoadPlaylist')

$hPLSave = GUICtrlCreateIcon($sIconDir & 'playlistsave0.ico', -1, 210, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_SavePlaylist')

$hPLExport = GUICtrlCreateIcon($sIconDir & 'export0.ico', -1, 250, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_ExportPlaylist')

$hPLAdd = GUICtrlCreateIcon($sIconDir & 'playlistadd0.ico', -1, 290, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_PlaylistAdd')

$hPLDel = GUICtrlCreateIcon($sIconDir & 'playlistdel0.ico', -1, 330, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_PlaylistDel')

$hPLRandom = GUICtrlCreateIcon($sIconDir & 'random0.ico', -1, 370, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_RandomSort')

$hPLRepeat = GUICtrlCreateIcon($sIconDir & 'repeat0.ico', -1, 410, 320, 32, 32)
GUICtrlSetOnEvent(-1, '_ChangeRepeat')

$hPLStatus1 = GUICtrlCreateLabel('', -2, 361, 270, 22, Default, $WS_EX_CLIENTEDGE)
GUICtrlSetFont(-1, 11, 400, 0, 'Arial')
GUICtrlSetColor(-1, 0xFFFFAA)
$hPLStatus2 = GUICtrlCreateLabel('', 268, 361, 295, 22, Default, $WS_EX_CLIENTEDGE)
GUICtrlSetFont(-1, 11, 400, 0, 'Arial')
GUICtrlSetColor(-1, 0xFFFFAA)

$hCmdLineInput = GUICtrlCreateEdit('', 40, -200, 400, 200)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlCreateButton('Send', 0, 80, 40, 20)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetOnEvent(-1, '_NewEntry')
; --- End Playlist-GUI ---

; --- Begin Config-GUI ---
$hConfigGui = GUICreate('Config', 320, 220, $aGuiPos[0] - (320 + $iWinBorder), $aGuiPos[1], BitOR($WS_POPUPWINDOW, $WS_THICKFRAME), $WS_EX_CONTROLPARENT, $hGui)
GUISetBkColor(0x000000)

GUICtrlCreatePic($sIconDir & 'backgr.jpg', 0, 0, 560, 160)
GUICtrlSetState(-1, $GUI_DISABLE)

GUICtrlCreateLabel('Starplayer-Configuration', 30, 10, 280, 30)
GUICtrlSetFont(-1, 18, 400, 2, 'Times New Roman')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

GUICtrlCreateGroup('', 5, 35, 310, 140)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hCOnTop = GUICtrlCreateCheckbox('Window on top', 15, 55, 280, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_SwitchOnTop')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hCFadeout = GUICtrlCreateCheckbox('Song cross-fade', 15, 78, 130, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_SwitchFadeOut')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hCFadeTime = GUICtrlCreateInput($iFadeTime, 155, 75, 42, 22, BitOR($ES_READONLY, $ES_CENTER, $ES_NUMBER))
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlCreateUpdown($hCFadeTime)
GUICtrlSetLimit(-1, 20, 1)
GUICtrlSetOnEvent(-1, '_ChangeFadeTime')

GUICtrlCreateLabel('sec.', 205, 78, 30, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hCSoundinfos = GUICtrlCreateCheckbox('Scroll Soundinfos on Taskbar-Icon', 15, 101, 280, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_SwitchSoundinfos')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hCTooltips = GUICtrlCreateCheckbox('Show Button-Tooltips', 15, 124, 280, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_SwitchTooltips')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

$hCStickVersion = GUICtrlCreateCheckbox('Inifile in Program-Dir (for USB-Stick)', 15, 147, 280, 16)
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_SwitchInifile')
GUICtrlSetColor(-1, 0xFFFFCC)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style
GUICtrlCreateGroup('', -99, -99, 1, 1)

$hCRegister = GUICtrlCreateButton('Register extensions ".mp3" && ".m3u" to Starplayer', 15, 190, 290, 25)
GUICtrlSetOnEvent(-1, '_RegFiletype')
GUICtrlSetFont(-1, 9, 400, 0, 'Arial')

If $sAppDir = '' Then
	GUICtrlSetState($hCStickVersion, $GUI_CHECKED)
	GUICtrlSetState($hCRegister, $GUI_DISABLE)
EndIf
; --- End Config-GUI ---

GUISetState(@SW_SHOW, $hGui)

_GDIPlus_Startup()
$hBackgr = _GDIPlus_BrushCreateSolid(0xFF000000)
$hBrushGreen = _GDIPlus_BrushCreateSolid(0xFF88FF00)
$hPenGrey = _GDIPlus_PenCreate(0xFF888888, 1)
$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hGui)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, 44, $hGraphic)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)

_GDIPlus_GraphicsFillRect($hBuffer, 0, 0, $iWidth, 44, $hBackgr)
_GDIPlus_GraphicsDrawRect($hBuffer, 0, 0, $iWidth - 1, 15, $hPenGrey)
_GDIPlus_GraphicsDrawRect($hBuffer, 0, 27, $iWidth - 1, 15, $hPenGrey)
$iWidth -= 3
_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)

Global $aAccelKeys[2][2] = [['{PGUP}', $hPLUp],['{PGDN}', $hPLDown]]
GUISetAccelerators($aAccelKeys, $hPLGui)

AdlibRegister('_HoverEffect', 100)
GUIRegisterMsg($WM_MOVE, '_WM_MOVE')
GUIRegisterMsg($WM_DROPFILES, '_WM_DROPFILES')
GUIRegisterMsg($WM_TIMER, '_WM_TIMER')
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
GUIRegisterMsg($WM_VSCROLL, '_WM_VSCROLL')

$fTooltips = Not $fTooltips
_SwitchTooltips()
$fSoundinfos = Not $fSoundinfos
_SwitchSoundinfos()
$fFadeOut = Not $fFadeOut
_SwitchFadeOut()
$fOnTop = Not $fOnTop
_SwitchOnTop()
$fRepeat = Not $fRepeat
_ChangeRepeat()

$iTimerVUMeter = _Timer_SetTimer($hGui, 10)

If $CmdLine[0] > 0 Then
	For $i = 1 To $CmdLine[0]
		If FileExists($CmdLine[$i]) Then
			Switch StringRight($CmdLine[$i], 4)
				Case '.mp3'
					_AddFileToPlaylist($CmdLine[$i])
				Case '.m3u'
					$sWorkDir = StringRegExpReplace($CmdLine[$i], '(.+\\).+', '$1')
					$aNewFiles = StringSplit(FileRead($CmdLine[$i]), @CRLF, 1)
					For $j = 1 To $aNewFiles[0]
						If Not StringInStr($aNewFiles[$j], '\') Then $aNewFiles[$j] = $sWorkDir & $aNewFiles[$j]
						If StringRight($aNewFiles[$j], 4) = '.mp3' And FileExists($aNewFiles[$j]) Then _AddFileToPlaylist($aNewFiles[$j])
					Next
			EndSwitch
		EndIf
	Next
	_PlaySound(0)
EndIf
_CalcPlaylistInfo()

While Sleep(50)
WEnd

#cs
	***** Begin Functions *****
#ce

Func _WM_VSCROLL($hWnd, $msg, $wParam, $lParam)
	If $lParam = GUICtrlGetHandle($hVolume) Then _ChangeVolume()
EndFunc   ;==>_WM_VSCROLL

Func _ChangeVolume()
	$iScriptVolume = 100 - GUICtrlRead($hVolume)
	ToolTip($iScriptVolume & '%')
	AdlibRegister('_RemoveToolTip', 800)
	If $hSoundOpen <> -1 Then _BASS_ChannelSetVolume($hSoundOpen, $iScriptVolume)
EndFunc   ;==>_ChangeVolume

Func _RemoveToolTip()
	AdlibUnRegister('_RemoveToolTip')
	ControlFocus($hPLGui, '', $hPLStatus1)
	ToolTip('')
EndFunc   ;==>_RemoveToolTip

Func _MuteVolume()
	$fMuteVolume = Not $fMuteVolume
	Switch $fMuteVolume
		Case True
			$iMuteVolume = $iScriptVolume
			$iScriptVolume = 0
			GUICtrlSetData($hVolume, 100)
			GUICtrlSetState($hVolume, $GUI_DISABLE)
			GUICtrlSetImage($hMute, $sIconDir & 'mute.ico')
			ToolTip('0%')
			AdlibRegister('_RemoveToolTip', 800)
			If $hSoundOpen <> -1 Then _BASS_ChannelSetVolume($hSoundOpen, $iScriptVolume)
		Case False
			$iScriptVolume = $iMuteVolume
			GUICtrlSetData($hVolume, 100 - $iScriptVolume)
			GUICtrlSetState($hVolume, $GUI_ENABLE)
			GUICtrlSetImage($hMute, $sIconDir & 'volcontrol1.ico')
			ToolTip($iScriptVolume & '%')
			AdlibRegister('_RemoveToolTip', 800)
			If $hSoundOpen <> -1 Then _BASS_ChannelSetVolume($hSoundOpen, $iScriptVolume)
	EndSwitch
EndFunc   ;==>_MuteVolume

Func _Minimize()
	GUISetState(@SW_MINIMIZE, $hGui)
EndFunc   ;==>_Minimize

Func _ShowPlaylist()
	Switch BitAND(WinGetState($hPLGui), 2)
		Case 2
			GUISetState(@SW_HIDE, $hPLGui)
		Case 0
			GUISetState(@SW_SHOW, $hPLGui)
	EndSwitch
EndFunc   ;==>_ShowPlaylist

Func _ShowConfig()
	Switch BitAND(WinGetState($hConfigGui), 2)
		Case 2
			GUISetState(@SW_HIDE, $hConfigGui)
			GUICtrlSetImage($hConfig, $sIconDir & 'config_close1.ico')
		Case 0
			GUISetState(@SW_SHOW, $hConfigGui)
			GUICtrlSetImage($hConfig, $sIconDir & 'config_open1.ico')
	EndSwitch
EndFunc   ;==>_ShowConfig

Func _PlaylistUp()
	Local $iSelect, $hWndPlaylist = GUICtrlGetHandle($hPlaylist), $sTmp
	$iSelect = ControlListView($hPLGui, '', $hPlaylist, 'GetSelected')
	If $iSelect = 0 Or $iSelect = '' Then Return
	If $iSelect - 1 = $iPlayIndex Then
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
		$iPlayIndex = $iSelect
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xFFBB55)
	ElseIf $iSelect = $iPlayIndex Then
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
		$iPlayIndex = $iSelect - 1
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xFFBB55)
	EndIf
	$sTmp = _GUICtrlListView_GetItemTextString($hWndPlaylist, $iSelect - 1)
	_GUICtrlListView_SetItemText($hWndPlaylist, $iSelect - 1, _GUICtrlListView_GetItemTextString($hWndPlaylist, $iSelect), -1)
	_GUICtrlListView_SetItemText($hWndPlaylist, $iSelect, $sTmp, -1)
	_GUICtrlListView_SetItemSelected($hWndPlaylist, -1, False)
	_GUICtrlListView_SetItemSelected($hWndPlaylist, $iSelect - 1, True)
	_GUICtrlListView_EnsureVisible($hWndPlaylist, $iSelect - 1)
	_EnumPlaylist()
EndFunc   ;==>_PlaylistUp

Func _PlaylistDown()
	Local $iSelect, $hWndPlaylist = GUICtrlGetHandle($hPlaylist), $sTmp, $iCount
	$iCount = _GUICtrlListView_GetItemCount($hWndPlaylist)
	$iSelect = ControlListView($hPLGui, '', $hPlaylist, 'GetSelected')
	If $iSelect + 1 = $iCount Or $iSelect = '' Then Return
	If $iSelect + 1 = $iPlayIndex Then
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
		$iPlayIndex = $iSelect
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xFFBB55)
	ElseIf $iSelect = $iPlayIndex Then
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
		$iPlayIndex = $iSelect + 1
		GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xFFBB55)
	EndIf
	$sTmp = _GUICtrlListView_GetItemTextString($hWndPlaylist, $iSelect + 1)
	_GUICtrlListView_SetItemText($hWndPlaylist, $iSelect + 1, _GUICtrlListView_GetItemTextString($hWndPlaylist, $iSelect), -1)
	_GUICtrlListView_SetItemText($hWndPlaylist, $iSelect, $sTmp, -1)
	_GUICtrlListView_SetItemSelected($hWndPlaylist, -1, False)
	_GUICtrlListView_SetItemSelected($hWndPlaylist, $iSelect + 1, True)
	_GUICtrlListView_EnsureVisible($hWndPlaylist, $iSelect + 1)
	_EnumPlaylist()
EndFunc   ;==>_PlaylistDown

Func _NewPlaylist()
	If _GUICtrlListView_GetItemCount($hPlaylist) = 0 Then Return
	AdlibUnRegister('_HoverEffect')
	If MsgBox(36 + 262144, $sTitle, 'Create a new Playlist. Are you sure?', 0, $hPLGui) = 6 Then
		_GUICtrlListView_BeginUpdate($hPlaylist)
		_StopSound()
		$iPlCount = 0
		Global $ahPlItem[1]
		_GUICtrlListView_DeleteAllItems($hPlaylist)
		_CalcPlaylistInfo()
		_GUICtrlListView_EndUpdate($hPlaylist)
	EndIf
	AdlibRegister('_HoverEffect', 100)
EndFunc   ;==>_NewPlaylist

Func _LoadPlaylist()
	Local $sLoadFilename, $aNewFiles
	AdlibUnRegister('_HoverEffect')
	GUICtrlSetImage($hPLLoad, $sIconDir & 'wait.ico')
	$sLoadFilename = FileOpenDialog('Choose MP3-Playlist', '', 'MP3-Playlist (*.m3u)', 3, '', $hGui)
	If Not @error Then
		$aNewFiles = StringSplit(FileRead($sLoadFilename), @CRLF, 1)
		For $i = 1 To $aNewFiles[0]
			If StringRight($aNewFiles[$i], 4) = '.mp3' And FileExists($aNewFiles[$i]) Then _AddFileToPlaylist($aNewFiles[$i])
		Next
	EndIf
	_CalcPlaylistInfo()
	GUICtrlSetImage($hPLLoad, $sIconDir & 'playlistopen0.ico')
	AdlibRegister('_HoverEffect', 100)
EndFunc   ;==>_LoadPlaylist

Func _SavePlaylist()
	Local $sSaveFilename, $hFile, $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iCount = 0 Then Return
	AdlibUnRegister('_HoverEffect')
	GUICtrlSetImage($hPLSave, $sIconDir & 'wait.ico')
	$sSaveFilename = FileSaveDialog('Choose a filename for MP3-Playlist', '', 'MP3-Playlist (*.m3u)', 18, '', $hGui)
	If Not @error Then
		If StringRight($sSaveFilename, 4) <> '.m3u' Then $sSaveFilename &= '.m3u'
		$hFile = FileOpen($sSaveFilename, 2)
		If $hFile <> -1 Then
			For $i = 0 To $iCount - 1
				FileWriteLine($hFile, _GUICtrlListView_GetItemText($hPlaylist, $i, 5))
			Next
			FileClose($hFile)
		EndIf
	EndIf
	GUICtrlSetImage($hPLSave, $sIconDir & 'playlistsave0.ico')
	AdlibRegister('_HoverEffect', 100)
EndFunc   ;==>_SavePlaylist

Func _ExportPlaylist()
	Local $sExportFolder, $hFile, $sSource, $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iCount = 0 Then Return
	AdlibUnRegister('_HoverEffect')
	GUICtrlSetImage($hPLExport, $sIconDir & 'wait.ico')
	$sExportFolder = FileSelectFolder('Choose a folder to export playlistfiles', '', 3, '', $hGui)
	If Not @error Then
		$hFile = FileOpen($sExportFolder & '\!Folder-Playlist.m3u', 2)
		If $hFile <> -1 Then
			For $i = 0 To $iCount - 1
				$sSource = _GUICtrlListView_GetItemText($hPlaylist, $i, 5)
				If FileCopy($sSource, $sExportFolder, 1) Then FileWriteLine($hFile, StringRegExpReplace($sSource, '.+\\(.+)', '$1'))
			Next
			FileClose($hFile)
		EndIf
	EndIf
	GUICtrlSetImage($hPLExport, $sIconDir & 'export0.ico')
	AdlibRegister('_HoverEffect', 100)
EndFunc   ;==>_ExportPlaylist

Func _PlaylistDel()
	Local $aSelect
	$aSelect = _GUICtrlListView_GetSelectedIndices($hPlaylist, True)
	If $aSelect[0] = 0 Then Return
	For $i = $aSelect[0] To 1 Step -1
		If $aSelect[$i] = $iPlayIndex Then _StopSound()
		If $aSelect[$i] < $iPlayIndex Then $iPlayIndex -= 1
		_GUICtrlListView_DeleteItem($hPlaylist, $aSelect[$i])
		_ArrayDelete($ahPlItem, $aSelect[$i])
	Next
	$iPlCount -= $aSelect[0]
	_CalcPlaylistInfo()
EndFunc   ;==>_PlaylistDel

Func _PlaylistAdd()
	Local $sNewFiles
	AdlibUnRegister('_HoverEffect')
	$sNewFiles = FileOpenDialog('Select MP3-File(s)', '', 'MP3-Files (*.mp3)', 7, '', $hGui)
	If Not @error Then
		$gaDropFiles = StringSplit($sNewFiles, '|', 2)
		If UBound($gaDropFiles) > 1 Then
			For $i = 1 To UBound($gaDropFiles) - 1
				$gaDropFiles[$i] = $gaDropFiles[0] & '\' & $gaDropFiles[$i]
			Next
			_ArrayDelete($gaDropFiles, 0)
		EndIf
		_DropEvent()
	EndIf
	_CalcPlaylistInfo()
	AdlibRegister('_HoverEffect', 100)
EndFunc   ;==>_PlaylistAdd

Func _Randomsort()
	Local $iCount, $aRan, $aItems, $aTmp
	$iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iCount = 0 Then Return
	Local $aRan[$iCount], $aItems[$iCount]
	_StopSound()
	GUICtrlSetImage($hPLRandom, $sIconDir & 'wait.ico')
	_GUICtrlListView_BeginUpdate($hPlaylist)
	For $i = 0 To UBound($aRan) - 1
		$aRan[$i] = Random(100000, 999999, 1)
		$aItems[$i] = _GUICtrlListView_GetItemTextString($hPlaylist, $i)
	Next
	For $i = 0 To UBound($aRan) - 2
		For $j = $i + 1 To UBound($aRan) - 1
			If $aRan[$i] > $aRan[$j] Then
				_SwitchVar($aRan[$i], $aRan[$j])
				_SwitchVar($aItems[$i], $aItems[$j])
			EndIf
		Next
	Next
	For $i = 0 To UBound($aRan) - 1
		_GUICtrlListView_SetItemText($hPlaylist, $i, $aItems[$i], -1)
	Next
	_EnumPlaylist()
	_GUICtrlListView_EndUpdate($hPlaylist)
	GUICtrlSetImage($hPLRandom, $sIconDir & 'random0.ico')
	_PlaySound(0)
EndFunc   ;==>_Randomsort

Func _SwitchVar(ByRef $a, ByRef $b)
	Local $tmp
	$tmp = $a
	$a = $b
	$b = $tmp
EndFunc   ;==>_SwitchVar

Func _EnumPlaylist()
	Local $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iCount = 0 Then Return
	For $i = 0 To $iCount - 1
		_GUICtrlListView_SetItemText($hPlaylist, $i, $i + 1, 0)
	Next
EndFunc   ;==>_EnumPlaylist

Func _ChangeRepeat()
	$fRepeat = Not $fRepeat
	If $fRepeat Then
		GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat_active0.ico')
		If $fTooltips Then GUICtrlSetTip($hPLRepeat, 'Repeat Playlist')
	Else
		GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat0.ico')
		If $fTooltips Then GUICtrlSetTip($hPLRepeat, "Don't repeat Playlist")
	EndIf
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'Repeat', $fRepeat)
EndFunc   ;==>_ChangeRepeat

Func _NewEntry()
	$gaDropFiles = StringSplit(GUICtrlRead($hCmdLineInput), @CRLF, 2)
	GUICtrlSetData($hCmdLineInput, '')
	_DropEvent()
;~ 	_PlaySound($iPlCount - 1, True)
EndFunc   ;==>_NewEntry

Func _DropEvent()
	Local $aFileList, $sWorkDir
	GUISetCursor(1, 1, $hPLGui)
	GUIRegisterMsg($WM_DROPFILES, '')
	_GUICtrlListView_BeginUpdate($hPlaylist)
	For $i = 0 To UBound($gaDropFiles) - 1
		If StringInStr(FileGetAttrib($gaDropFiles[$i]), 'D') Then
			$aFileList = _RecursiveFileListToArray($gaDropFiles[$i], '\.mp3\z')
			For $j = 1 To $aFileList[0]
				_AddFileToPlaylist($aFileList[$j])
			Next
		Else
			Switch StringRight($gaDropFiles[$i], 4)
				Case '.m3u'
					$sWorkDir = StringRegExpReplace($gaDropFiles[$i], '(.+\\).+', '$1')
					$aFileList = StringSplit(FileRead($gaDropFiles[$i]), @CRLF, 1)
					For $j = 1 To $aFileList[0]
						If Not StringInStr($aFileList[$j], '\') Then $aFileList[$j] = $sWorkDir & $aFileList[$j]
						_AddFileToPlaylist($aFileList[$j])
					Next
				Case '.mp3'
					_AddFileToPlaylist($gaDropFiles[$i])
			EndSwitch
		EndIf
	Next
	_GUICtrlListView_EndUpdate($hPlaylist)
	GUIRegisterMsg($WM_DROPFILES, '_WM_DROPFILES')
	_CalcPlaylistInfo()
	GUISetCursor(2, 1, $hPLGui)
EndFunc   ;==>_DropEvent

Func _AddFileToPlaylist($sFilepath)
	If Not FileExists($sFilepath) Then Return
	Local $aID3, $sNewItem
	$aID3 = _ReadID3Tag($sFilepath)
	If Not @error Then
		ReDim $ahPlItem[$iPlCount + 1]
		$sNewItem = $iPlCount + 1 & '|' & $aID3[1][1] & '|' & $aID3[0][1] & '|' & $aID3[4][1] & '|' & $aID3[9][1] & '|' & $sFilepath
		$ahPlItem[$iPlCount] = GUICtrlCreateListViewItem($sNewItem, $hPlaylist)
		$iPlCount += 1
	EndIf
EndFunc   ;==>_AddFileToPlaylist

Func _WM_DROPFILES($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $lParam
	Local $nSize, $pFileName
	Local $nAmt = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', 0xFFFFFFFF, 'ptr', 0, 'int', 255)
	For $i = 0 To $nAmt[0] - 1
		$nSize = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', 0, 'int', 0)
		$nSize = $nSize[0] + 1
		$pFileName = DllStructCreate('wchar[' & $nSize & ']')
		DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', DllStructGetPtr($pFileName), 'int', $nSize)
		ReDim $gaDropFiles[$i + 1]
		$gaDropFiles[$i] = DllStructGetData($pFileName, 1)
		$pFileName = 0
	Next
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_DROPFILES

Func _WM_MOVE($hWnd, $iMsg, $iwParam, $ilParam)
	Local $aGuiPos
	Switch $hWnd
		Case $hGui
			$aGuiPos = WinGetPos($hGui)
			WinMove($hPLGui, '', $aGuiPos[0], $aGuiPos[1] + 220 + $iWinBorder)
			WinMove($hConfigGui, '', $aGuiPos[0] - (320 + $iWinBorder), $aGuiPos[1])
		Case $hPLGui
			$aGuiPos = WinGetPos($hPLGui)
			WinMove($hGui, '', $aGuiPos[0], $aGuiPos[1] - 220 - $iWinBorder)
			WinMove($hConfigGui, '', $aGuiPos[0] - (320 + $iWinBorder), $aGuiPos[1] - 220 - $iWinBorder)
		Case $hConfigGui
			$aGuiPos = WinGetPos($hConfigGui)
			WinMove($hGui, '', $aGuiPos[0] + 320 + $iWinBorder, $aGuiPos[1])
			WinMove($hPLGui, '', $aGuiPos[0] + 320 + $iWinBorder, $aGuiPos[1] + 220 + $iWinBorder)
	EndSwitch
	If Not BitAND(WinGetState($hGui), 16) Then
		$aGuiPos = WinGetPos($hGui)
		If $sAppDir = '' Then FileChangeDir(@ScriptDir)
		IniWrite($sInifile, 'Settings', 'MainPosX', $aGuiPos[0])
		IniWrite($sInifile, 'Settings', 'MainPosY', $aGuiPos[1])
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_MOVE

Func _SetPosition()
	Local $aInfo, $iPercent
	$aInfo = GUIGetCursorInfo($hGui)
	If $aInfo[4] = $hPosition Then
		$iPercent = 100 / 500 * ($aInfo[0] - 50)
		_BASS_ChannelSetPosition($hSoundOpen, $iLength / 100 * $iPercent, $BASS_POS_BYTE)
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_SetPosition

Func _ChangeFadeTime()
	$iFadeTime = GUICtrlRead($hCFadeTime)
	If $iFadeTime < 5000 Then
		$iFadeLength = $iFadeTime
	Else
		$iFadeLength = 5000
	EndIf
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'FadeTime', $iFadeTime)
EndFunc   ;==>_ChangeFadeTime

Func _WM_TIMER($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $ilParam
	If $hSoundOpen <> -1 Then
		Local $iLevel, $iLeft, $iRight, $iSecs, $iValL, $iValR
		Switch _Timer_GetTimerID($iwParam)
			Case $iTimerVUMeter
				$iPos = _BASS_ChannelGetPosition($hSoundOpen, $BASS_POS_BYTE)
				$iSecs = Int(_BASS_ChannelBytes2Seconds($hSoundOpen, $iPos))
				If $iSeconds > 0 And $iSecs >= ($iSeconds - 1) - $iFadeTime * $fFadeOut Then
					If $iPlayIndex < _GUICtrlListView_GetItemCount($hPlaylist) - 1 Then
						_PlaySound($iPlayIndex + 1)
					Else
						If $fRepeat Then _PlaySound(0)
					EndIf
				EndIf
				If $iSecs <> $iOld Then
					$iOld = $iSecs
					GUICtrlSetData($hDuration, _FormatTime($iSecs, $iSeconds))
				EndIf
				GUICtrlSetData($hPosition, Int(100 / $iLength * $iPos))
				$iLevel = _BASS_ChannelGetLevel($hSoundOpen)
				$iLeft = _LoWord($iLevel)
				If $iLeft > 32766 Then $iLeft = 0
				$iRight = _HiWord($iLevel)
				If $iRight > 32766 Then $iRight = 0
				If $iLeft > $iPeakL Then $iPeakL = $iLeft
				If $iRight > $iPeakR Then $iPeakR = $iRight
				$iValL = $iWidth / $iHigh * $iPeakL
				If $iValL > $iWidth Then $iValL = $iWidth
				$iValR = $iWidth / $iHigh * $iPeakR
				If $iValR > $iWidth Then $iValR = $iWidth
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 3, $iValL, 10, $hBrushGreen)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 30, $iValR, 10, $hBrushGreen)
				_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)
				_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 3, $iValL, 10, $hBackgr)
				_GDIPlus_GraphicsFillRect($hBuffer, 1, 30, $iValR, 10, $hBackgr)
				$iPeakL -= 1200
				$iPeakR -= 1200
		EndSwitch
	Else
		_GDIPlus_GraphicsFillRect($hBuffer, 1, 3, $iWidth, 10, $hBackgr)
		_GDIPlus_GraphicsFillRect($hBuffer, 1, 30, $iWidth, 10, $hBackgr)
		_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 50, 110, $iWidth, 44)
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_TIMER

Func _StartSound()
	Local $aSelect, $iSelect
	Local $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iCount = 0 Then Return
	$aSelect = _GUICtrlListView_GetSelectedIndices($hPlaylist, True)
	If $aSelect[0] = 0 Then
		$iSelect = 0
	Else
		$iSelect = $aSelect[1]
	EndIf
	_PlaySound($iSelect, True)
EndFunc   ;==>_StartSound

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	Local $iCode, $tNMHDR, $tInfo, $iIndex
	If $hWnd = $hPLGui Then
		$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
		$iCode = DllStructGetData($tNMHDR, 'Code')
		Switch $iCode
			Case $NM_DBLCLK
				$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
				$iIndex = DllStructGetData($tInfo, 'Index')
				_PlaySound($iIndex, True)
		EndSwitch
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _PlaySound($iSelect, $fNoFade = False)
	Local $sPath
	If $iPlayIndex <> -1 Then GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
	$iPlayIndex = $iSelect
	GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xFFBB55)
	$sPath = _GUICtrlListView_GetItemText($hPlaylist, $iSelect, 5)
	GUICtrlSetImage($hPlay, $sIconDir & 'pause0.ico')
	GUICtrlSetOnEvent($hPlay, '_PauseSound')
	If $hSoundOpen <> -1 Then
		If _BASS_ChannelIsSliding($hSoundFade, $BASS_ATTRIB_VOL) Then _BASS_ChannelStop($hSoundFade)
		$hSoundFade = $hSoundOpen
		If $fNoFade Or Not $fFadeOut Then
			_BASS_ChannelStop($hSoundFade)
		Else
			_BASS_ChannelSlideAttribute($hSoundFade, $BASS_ATTRIB_VOL, 0, $iFadeLength)
		EndIf
		$fPause = False
	EndIf
	$hSoundOpen = _BASS_StreamCreateFile(False, $sPath, 0, 0, BitOR($BASS_STREAM_PRESCAN, $BASS_STREAM_AUTOFREE))
	_BASS_ChannelPlay($hSoundOpen, 0)
	_BASS_ChannelSetVolume($hSoundOpen, $iScriptVolume)
	If $fFadeOut Then
		_BASS_ChannelSetVolume($hSoundOpen, 0)
		_BASS_ChannelSlideAttribute($hSoundOpen, $BASS_ATTRIB_VOL, $iScriptVolume / 100, 1000)
	EndIf
	$iLength = _BASS_ChannelGetLength($hSoundOpen, $BASS_POS_BYTE)
	$iSeconds = _BASS_ChannelBytes2Seconds($hSoundOpen, $iLength)
	GUICtrlSetData($hDuration, _FormatTime(0, $iSeconds))
	$sID3Tags = _Bass_Tags_Read($hSoundOpen, '%IFV2(%ARTI,%ARTI,no Artist) - %IFV2(%TITL,%TITL,no Title)')
	$sID3Tags = StringReplace($sID3Tags, '&', '&&')
	GUICtrlSetData($hLabel, $sID3Tags)
	$sID3Tags = StringFormat('%32s', ' ') & $sID3Tags
	_GUICtrlListView_EnsureVisible($hPlaylist, $iPlayIndex)
EndFunc   ;==>_PlaySound

Func _PauseSound()
	Switch $fPause
		Case True
			_BASS_ChannelPlay($hSoundOpen, 0)
			GUICtrlSetImage($hPlay, $sIconDir & 'pause0.ico')
		Case False
			_BASS_ChannelPause($hSoundOpen)
			GUICtrlSetImage($hPlay, $sIconDir & 'pause_active.ico')
	EndSwitch
	$fPause = Not $fPause
EndFunc   ;==>_PauseSound

Func _StopSound()
	If $hSoundOpen <> -1 Then
		_BASS_ChannelStop($hSoundOpen)
		_BASS_StreamFree($hSoundOpen)
		$hSoundOpen = -1
	EndIf
	If $iPlayIndex <> -1 Then GUICtrlSetBkColor($ahPlItem[$iPlayIndex], 0xDDDDDD)
	$iPlayIndex = -1
	$fPause = False
	$sID3Tags = ''
	GUICtrlSetData($hLabel, '')
	GUICtrlSetImage($hPlay, $sIconDir & 'play0.ico')
	GUICtrlSetOnEvent($hPlay, '_StartSound')
EndFunc   ;==>_StopSound

Func _PrevSound()
	Local $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $fRepeat And $iPlayIndex = 0 Then Return _PlaySound($iCount - 1, True)
	If $iCount = 0 Or $iPlayIndex = 0 Then Return
	_PlaySound($iPlayIndex - 1, True)
EndFunc   ;==>_PrevSound

Func _NextSound()
	Local $iCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $fRepeat And $iPlayIndex = $iCount - 1 Then Return _PlaySound(0, True)
	If $iCount = 0 Or $iPlayIndex >= $iCount - 1 Then Return
	_PlaySound($iPlayIndex + 1, True)
EndFunc   ;==>_NextSound

Func _ScrollTitle()
	$iStart += 1
	If $iStart > StringLen($sID3Tags) Then $iStart = 1
	WinSetTitle($hGui, '', StringMid($sID3Tags, $iStart, 32))
EndFunc   ;==>_ScrollTitle

Func _FormatTime($iSecs, $iAllSecs)
	Local $iMins, $iAllMins
	$iMins = Int($iSecs / 60)
	$iSecs = Mod($iSecs, 60)
	$iAllMins = Int($iAllSecs / 60)
	$iAllSecs = Mod($iAllSecs, 60)
	Return StringFormat('%02i:%02i / %02i:%02i', $iMins, $iSecs, $iAllMins, $iAllSecs)
EndFunc   ;==>_FormatTime

Func _RegFiletype()
	If Not @Compiled Then Return MsgBox(48 + 262144, $sTitle, 'Error! Script must be compiled!', 0, $hConfigGui)
	Local $sHKCUSoftware, $sFileType, $sFileTypeName, $sFileTypeDescriptopn, $sFileTypeIcon, $sFileTypeOpenCommand, $msg
	$sHKCUSoftware = 'HKCU\Software\'
	$sFileTypeOpenCommand = Chr(34) & @ScriptFullPath & Chr(34) & ' "%1"'
	; Register MP3-Files .mp3
	$sFileType = '.mp3'
	$sFileTypeName = 'StarplayerMP3'
	$sFileTypeDescriptopn = 'Starplayer MP3 Audiodatei'
	$sFileTypeIcon = @ScriptDir & '\icons\mp3.ico,0'
	RegWrite($sHKCUSoftware & 'Microsoft\Windows\CurrentVersion\Explorer\FileExts\' & $sFileType, 'Progid', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, '', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'Content Type', 'REG_SZ', 'audio/mpeg')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'PerceivedType', 'REG_SZ', 'audio')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName, '', 'REG_SZ', $sFileTypeDescriptopn)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Defaulticon', '', 'REG_SZ', $sFileTypeIcon)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\open\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\play\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	; Register Playlist .m3u
	$sFileType = '.m3u'
	$sFileTypeName = 'StarplayerM3U'
	$sFileTypeDescriptopn = 'Starplayer MP3 Playlist'
	$sFileTypeIcon = @ScriptDir & '\icons\m3u.ico,0'
	RegWrite($sHKCUSoftware & 'Microsoft\Windows\CurrentVersion\Explorer\FileExts\' & $sFileType, 'Progid', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, '', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'Content Type', 'REG_SZ', 'audio/mpegurl')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'PerceivedType', 'REG_SZ', 'audio')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName, '', 'REG_SZ', $sFileTypeDescriptopn)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Defaulticon', '', 'REG_SZ', $sFileTypeIcon)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\open\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\play\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	$msg = 'The extensions ".mp3" and ".m3u" are now registered to:' & @CRLF
	$msg &= 'Starplayer ("' & @ScriptFullPath & '")'
	MsgBox(64 + 262144, $sTitle, $msg, 0, $hConfigGui)
EndFunc   ;==>_RegFiletype

Func _SwitchOnTop()
	$fOnTop = Not $fOnTop
	Switch $fOnTop
		Case True
			GUICtrlSetState($hCOnTop, $GUI_CHECKED)
			WinSetOnTop($hGui, '', 1)
		Case False
			GUICtrlSetState($hCOnTop, $GUI_UNCHECKED)
			WinSetOnTop($hGui, '', 0)
	EndSwitch
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'OnTop', $fOnTop)
EndFunc   ;==>_SwitchOnTop

Func _SwitchFadeOut()
	$fFadeOut = Not $fFadeOut
	Switch $fFadeOut
		Case True
			GUICtrlSetState($hCFadeout, $GUI_CHECKED)
			GUICtrlSetState($hCFadeTime, $GUI_ENABLE)
		Case False
			GUICtrlSetState($hCFadeout, $GUI_UNCHECKED)
			GUICtrlSetState($hCFadeTime, $GUI_DISABLE)
	EndSwitch
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'FadeOut', $fFadeOut)
EndFunc   ;==>_SwitchFadeOut

Func _SwitchSoundinfos()
	$fSoundinfos = Not $fSoundinfos
	Switch $fSoundinfos
		Case True
			GUICtrlSetState($hCSoundinfos, $GUI_CHECKED)
			AdlibRegister('_ScrollTitle', 100)
		Case False
			GUICtrlSetState($hCSoundinfos, $GUI_UNCHECKED)
			AdlibUnRegister('_ScrollTitle')
			WinSetTitle($hGui, '', $sTitle)
	EndSwitch
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'Soundinfos', $fSoundinfos)
EndFunc   ;==>_SwitchSoundinfos

Func _SwitchTooltips()
	$fTooltips = Not $fTooltips
	Switch $fTooltips
		Case True
			GUICtrlSetState($hCTooltips, $GUI_CHECKED)
			GUICtrlSetTip($hMin, 'Minimize Starplayer')
			GUICtrlSetTip($hClose, 'Close Starplayer')
			GUICtrlSetTip($hConfig, 'Open/Close Configuration')
			GUICtrlSetTip($hPLShow, 'Open/Close Playlist')
			GUICtrlSetTip($hPLUp, 'Selected Title up')
			GUICtrlSetTip($hPLDown, 'Selected Title down')
			GUICtrlSetTip($hVolume, 'Change Volume')
			GUICtrlSetTip($hMute, 'Mute volume')
			GUICtrlSetTip($hPLNew, 'New Playlist')
			GUICtrlSetTip($hPLLoad, 'Load Playlist')
			GUICtrlSetTip($hPLSave, 'Save Playlist')
			GUICtrlSetTip($hPLExport, 'Export Playlistfiles to chosen folder')
			GUICtrlSetTip($hPLAdd, 'Add MP3s to Playlist')
			GUICtrlSetTip($hPLDel, 'Delete selected MP3s from Playlist')
			GUICtrlSetTip($hPLRandom, 'Playlist randomly order')
			If $fRepeat Then
				GUICtrlSetTip($hPLRepeat, 'Repeat Playlist')
			Else
				GUICtrlSetTip($hPLRepeat, "Don't repeat Playlist")
			EndIf
		Case False
			GUICtrlSetState($hCTooltips, $GUI_UNCHECKED)
			GUICtrlSetTip($hMin, '')
			GUICtrlSetTip($hClose, '')
			GUICtrlSetTip($hConfig, '')
			GUICtrlSetTip($hPLShow, '')
			GUICtrlSetTip($hPLUp, '')
			GUICtrlSetTip($hPLDown, '')
			GUICtrlSetTip($hVolume, '')
			GUICtrlSetTip($hMute, '')
			GUICtrlSetTip($hPLNew, '')
			GUICtrlSetTip($hPLLoad, '')
			GUICtrlSetTip($hPLSave, '')
			GUICtrlSetTip($hPLExport, '')
			GUICtrlSetTip($hPLAdd, '')
			GUICtrlSetTip($hPLDel, '')
			GUICtrlSetTip($hPLRandom, '')
			GUICtrlSetTip($hPLRepeat, '')
	EndSwitch
	If $sAppDir = '' Then FileChangeDir(@ScriptDir)
	IniWrite($sInifile, 'Settings', 'Tooltips', $fTooltips)
EndFunc   ;==>_SwitchTooltips

Func _SwitchInifile()
	Switch BitAND(GUICtrlRead($hCStickVersion), $GUI_CHECKED) = $GUI_CHECKED
		Case True
			$sAppDir = ''
			GUICtrlSetState($hCRegister, $GUI_DISABLE)
		Case False
			$sAppDir = @AppDataDir & '\StarplayerV3\'
			GUICtrlSetState($hCRegister, $GUI_ENABLE)
	EndSwitch
	$sInifile = $sAppDir & 'Starplayer.ini'
	If Not IniWrite($sInifile, 'Settings', 'AppDir', $sAppDir) Then
		GUICtrlSetState($hCStickVersion, $GUI_UNCHECKED)
		$sAppDir = @AppDataDir & '\StarplayerV3\'
		$sInifile = $sAppDir & 'Starplayer.ini'
		GUICtrlSetState($hCRegister, $GUI_ENABLE)
		MsgBox(48 + 262144, $sTitle, 'Write access denied!' & @CRLF & "Inifile can't write in Program-Dir.", 0, $hConfigGui)
	EndIf
EndFunc   ;==>_SwitchInifile

Func _CalcPlaylistInfo()
	Local $iPlSize, $iPlDuration, $aTime, $iLVCount = _GUICtrlListView_GetItemCount($hPlaylist)
	If $iLVCount > 0 Then
		For $i = 0 To $iLVCount - 1
			$aTime = StringSplit(_GUICtrlListView_GetItemText($hPlaylist, $i, 3), ':', 2)
			If UBound($aTime) > 1 Then $iPlDuration += _TimeToTicks($aTime[0], $aTime[1], $aTime[2])
			$iPlSize += FileGetSize(_GUICtrlListView_GetItemText($hPlaylist, $i, 5))
		Next
		_GUICtrlListView_SetColumnWidth($hPlaylist, 5, $LVSCW_AUTOSIZE)
	EndIf
	GUICtrlSetData($hPLStatus1, '  ' & $iLVCount & ' File' & _Iif($iLVCount <> 1, 's', '') & ' (' & _ByteAutoSize($iPlSize, 2, 0, False) & ')')
	GUICtrlSetData($hPLStatus2, '  Playlist total time = ' & _NewTicksToTime($iPlDuration, True))
EndFunc   ;==>_CalcPlaylistInfo

Func _Exit()
	_Timer_KillAllTimers($hGui)
	AdlibUnRegister('_ScrollTitle')
	AdlibUnRegister('_HoverEffect')
	If $hSoundFade <> -1 Then _BASS_StreamFree($hSoundFade)
	If $hSoundOpen <> -1 Then _BASS_StreamFree($hSoundOpen)
	_BASS_Free()
	_GDIPlus_BrushDispose($hBackgr)
	_GDIPlus_BrushDispose($hBrushGreen)
	_GDIPlus_PenDispose($hPenGrey)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_Shutdown()
	IniWrite($sInifile, 'Settings', 'ScriptVolume', $iScriptVolume)
	Exit
EndFunc   ;==>_Exit

Func _HoverEffect()
	Local $aInfo, $aPos, $hInfo = $hGui
	$aInfo = GUIGetCursorInfo($hGui)
	If BitAND(WinGetState($hPLGui), 2) Then
		If $aInfo[0] >= 0 And $aInfo[0] <= 560 Then
			Select
				Case $aInfo[1] >= 0 And $aInfo[1] < 220
					If Not BitAND(WinGetState($hGui), 8) Then _WinAPI_SetFocus($hGui)
					$hInfo = $hGui
				Case $aInfo[1] > 220 And $aInfo[1] < 600
					If Not BitAND(WinGetState($hPLGui), 8) Then _WinAPI_SetFocus($hPLGui)
					$hInfo = $hPLGui
			EndSelect
		EndIf
	EndIf
	$aInfo = GUIGetCursorInfo($hInfo)
	If $aInfo[4] = $iHover Then Return
	Switch $iHover
		Case $hConfig
			If BitAND(WinGetState($hConfigGui), 2) Then
				GUICtrlSetImage($hConfig, $sIconDir & 'config_open0.ico')
			Else
				GUICtrlSetImage($hConfig, $sIconDir & 'config_close0.ico')
			EndIf
		Case $hMin
			GUICtrlSetImage($hMin, $sIconDir & 'min0.ico')
		Case $hClose
			GUICtrlSetImage($hClose, $sIconDir & 'close0.ico')
		Case $hPrev
			GUICtrlSetImage($hPrev, $sIconDir & 'prev0.ico')
		Case $hStop
			GUICtrlSetImage($hStop, $sIconDir & 'stop0.ico')
		Case $hPlay
			If Not $fPause Then
				If $hSoundOpen <> -1 Then
					GUICtrlSetImage($hPlay, $sIconDir & 'pause0.ico')
				Else
					GUICtrlSetImage($hPlay, $sIconDir & 'play0.ico')
				EndIf
			EndIf
		Case $hNext
			GUICtrlSetImage($hNext, $sIconDir & 'next0.ico')
		Case $hPLShow
			GUICtrlSetImage($hPLShow, $sIconDir & 'playlist0.ico')
		Case $hPLUp
			GUICtrlSetImage($hPLUp, $sIconDir & 'up0.ico')
		Case $hPLDown
			GUICtrlSetImage($hPLDown, $sIconDir & 'down0.ico')
		Case $hMute
			If Not $fMuteVolume Then GUICtrlSetImage($hMute, $sIconDir & 'volcontrol0.ico')
		Case $hPLNew
			GUICtrlSetImage($hPLNew, $sIconDir & 'playlistnew0.ico')
		Case $hPLLoad
			GUICtrlSetImage($hPLLoad, $sIconDir & 'playlistopen0.ico')
		Case $hPLSave
			GUICtrlSetImage($hPLSave, $sIconDir & 'playlistsave0.ico')
		Case $hPLExport
			GUICtrlSetImage($hPLExport, $sIconDir & 'export0.ico')
		Case $hPLAdd
			GUICtrlSetImage($hPLAdd, $sIconDir & 'playlistadd0.ico')
		Case $hPLDel
			GUICtrlSetImage($hPLDel, $sIconDir & 'playlistdel0.ico')
		Case $hPLRandom
			GUICtrlSetImage($hPLRandom, $sIconDir & 'random0.ico')
		Case $hPLRepeat
			If $fRepeat Then
				GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat_active0.ico')
			Else
				GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat0.ico')
			EndIf
	EndSwitch
	$iHover = $aInfo[4]
	Switch $iHover
		Case $hConfig
			If BitAND(WinGetState($hConfigGui), 2) Then
				GUICtrlSetImage($hConfig, $sIconDir & 'config_open1.ico')
			Else
				GUICtrlSetImage($hConfig, $sIconDir & 'config_close1.ico')
			EndIf
		Case $hMin
			GUICtrlSetImage($hMin, $sIconDir & 'min1.ico')
		Case $hClose
			GUICtrlSetImage($hClose, $sIconDir & 'close1.ico')
		Case $hPrev
			GUICtrlSetImage($hPrev, $sIconDir & 'prev1.ico')
		Case $hStop
			GUICtrlSetImage($hStop, $sIconDir & 'stop1.ico')
		Case $hPlay
			If Not $fPause Then
				If $hSoundOpen <> -1 Then
					GUICtrlSetImage($hPlay, $sIconDir & 'pause1.ico')
				Else
					GUICtrlSetImage($hPlay, $sIconDir & 'play1.ico')
				EndIf
			EndIf
		Case $hNext
			GUICtrlSetImage($hNext, $sIconDir & 'next1.ico')
		Case $hPLShow
			GUICtrlSetImage($hPLShow, $sIconDir & 'playlist1.ico')
		Case $hPLUp
			GUICtrlSetImage($hPLUp, $sIconDir & 'up1.ico')
		Case $hPLDown
			GUICtrlSetImage($hPLDown, $sIconDir & 'down1.ico')
		Case $hMute
			If Not $fMuteVolume Then
				GUICtrlSetImage($hMute, $sIconDir & 'volcontrol1.ico')
			Else
				GUICtrlSetImage($hMute, $sIconDir & 'mute.ico')
			EndIf
		Case $hPLNew
			GUICtrlSetImage($hPLNew, $sIconDir & 'playlistnew1.ico')
		Case $hPLLoad
			GUICtrlSetImage($hPLLoad, $sIconDir & 'playlistopen1.ico')
		Case $hPLSave
			GUICtrlSetImage($hPLSave, $sIconDir & 'playlistsave1.ico')
		Case $hPLExport
			GUICtrlSetImage($hPLExport, $sIconDir & 'export1.ico')
		Case $hPLAdd
			GUICtrlSetImage($hPLAdd, $sIconDir & 'playlistadd1.ico')
		Case $hPLDel
			GUICtrlSetImage($hPLDel, $sIconDir & 'playlistdel1.ico')
		Case $hPLRandom
			GUICtrlSetImage($hPLRandom, $sIconDir & 'random1.ico')
		Case $hPLRepeat
			If $fRepeat Then
				GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat_active1.ico')
			Else
				GUICtrlSetImage($hPLRepeat, $sIconDir & 'repeat1.ico')
			EndIf
		Case Else
			$iHover = -1
	EndSwitch
EndFunc   ;==>_HoverEffect

Func _NewTicksToTime($iTicks, $iStringFormat = False)
	Local $iDays, $iHours, $iMins, $iSecs = Int($iTicks / 1000)
	$iDays = Int($iSecs / 86400)
	$iSecs = Mod($iSecs, 86400)
	$iHours = Int($iSecs / 3600)
	$iSecs = Mod($iSecs, 3600)
	$iMins = Int($iSecs / 60)
	$iSecs = Mod($iSecs, 60)
	If $iStringFormat Then Return '  ' & $iDays & ' day' & _Iif($iDays <> 1, 's', '') & StringFormat(' %02i:%02i:%02i', $iHours, $iMins, $iSecs)
	Local $aTime[4] = [$iDays, $iHours, $iMins, $iSecs]
	Return $aTime
EndFunc   ;==>_NewTicksToTime

Func _ByteAutoSize($iSize, $iRound = 2, $iFormat = 0, $bThousands = True)
	Local $aSize[4] = [' Byte', ' KByte', ' MByte', ' GByte'], $sReturn
	If $iFormat < 0 Or $iFormat > 4 Then $iFormat = 0
	If $iRound < 0 Or $iRound > 8 Then $iRound = 2
	If Not IsBool($bThousands) Then $bThousands = False
	$iSize = Abs($iSize)
	If $iFormat = 0 Then
		For $i = 30 To 0 Step -10
			If $iSize > (2 ^ $i) Then
				$iFormat = $i / 10 + 1
				ExitLoop
			EndIf
		Next
	EndIf
	If $iFormat = 0 Then $iFormat = 1
	$sReturn = StringFormat('%.' & $iRound & 'f', Round($iSize / (2 ^ (($iFormat - 1) * 10)), $iRound))
	If $bThousands Then $sReturn = _StringAddThousandsSep($sReturn, ',', '.')
	Return $sReturn & $aSize[$iFormat - 1]
EndFunc   ;==>_ByteAutoSize

; #FUNCTION# ====================================================================================================================
; Name...........: _StringAddThousandsSep
; Description ...: Returns the original numbered string with the Thousands delimiter inserted.
; Syntax.........: _StringAddThousandsSep($sString[, $sThousands = -1[, $sDecimal = -1]])
; Parameters ....: $sString    - The string to be converted.
;                  $sThousands - Optional: The Thousands delimiter
;                  $sDecimal   - Optional: The decimal delimiter
; Return values .: Success - The string with Thousands delimiter added.
; Author ........: SmOke_N (orignal _StringAddComma
; Modified.......: Valik (complete re-write, new function name)
; Remarks .......:
; Related .......:
; Link ..........;
; Example .......; Yes
; ===============================================================================================================================
Func _StringAddThousandsSep($sString, $sThousands = -1, $sDecimal = -1)
	Local $sResult = "" ; Force string
	Local $rKey = "HKCU\Control Panel\International"
	If $sDecimal = -1 Then $sDecimal = RegRead($rKey, "sDecimal")
	If $sThousands = -1 Then $sThousands = RegRead($rKey, "sThousand")
	Local $aNumber = StringRegExp($sString, "(\D?\d+)\D?(\d*)", 1) ; This one works for negatives.
	If UBound($aNumber) = 2 Then
		Local $sLeft = $aNumber[0]
		While StringLen($sLeft)
			$sResult = $sThousands & StringRight($sLeft, 3) & $sResult
			$sLeft = StringTrimRight($sLeft, 3)
		WEnd
		$sResult = StringTrimLeft($sResult, StringLen($sThousands)) ; Strip leading thousands separator
		If $aNumber[1] <> "" Then $sResult &= $sDecimal & $aNumber[1]
	EndIf
	Return $sResult
EndFunc   ;==>_StringAddThousandsSep